package com.fp.persistence.pgeneral.trans;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENETRANSACTIONEVENT*/
@Embeddable
public class TgeneTransactionEventKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="EVENTCODE", nullable=false,updatable=false)

/**
* Codigo de evento a ejecutar, Ejemplo PAYMENT pago de credito
*/
private String eventcode;

@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

/**Contructor por defecto*/
public TgeneTransactionEventKey(){}
/**Contructor de TgeneTransactionEventKey
@param pEventcode Codigo de evento a ejecutar, Ejemplo PAYMENT pago de credito
@param pModulecode Codigo de modulo
*/
public TgeneTransactionEventKey(String pEventcode,String pModulecode){
 eventcode=pEventcode;
 modulecode=pModulecode;
}
/**Obtiene el valor de eventcode
@return valor de eventcode*/
public String getEventcode(){
  return eventcode;
}
/**Fija el valor de eventcode
@param pEventcode nuevo Valor de eventcode*/
public void setEventcode(String pEventcode){
  eventcode=pEventcode;
}

/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Implementación de la comparación de TgeneTransactionEventKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneTransactionEventKey))return false;
  TgeneTransactionEventKey that = (TgeneTransactionEventKey) o;
  if (this.getEventcode() == null || that.getEventcode() == null){
      return false;
  }
  if (! this.getEventcode().equals(that.getEventcode())){
    return false;
  }
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneTransactionEventKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getEventcode() == null ? 0 : this.getEventcode().hashCode());
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
